#include "adc.h"

void ADC_Init(void)
{
	ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);
	ADMUX = 0;
	ADMUX |= (1<<REFS0);
}

uint16_t Read_Channel(void)
{
	uint8_t i;
	uint16_t result = 0;
	
	ADCSRA |= (1<<ADSC);
	while(ADCSRA & (1<<ADSC))
	{
		;
	}
	for(i=0;i<4;i++)
	{
		ADCSRA |= (1<<ADSC);
		while(ADCSRA & (1<<ADSC))
		{
			;
		}
    result += ADC;
	}
	result /= 4;
	return result;
	
}

void Get_ADC(void)
{
	uint32_t adcval = 0;
	//uint32_t adcval1 = 0;
	char s[7];

	//adcval = Read_Channel();
	adcval = (Read_Channel() * ADC_CALIBRATION)/1000;
	itoa(adcval, s, 10);
	
	#if DEBUG_ON
		uart_puts("avr_adc: ");
		uart_puts(s);
		uart_puts(" mV\r\n");
	#endif
}
